const w = 532;
const h = 40
const gap = 10;

export default class Marquee extends FYGE.Sprite {
    textwrapper: FYGE.Sprite;
    datas: string[];
    buttonTxt1: FYGE.TextField;
    buttonTxt2: FYGE.TextField;
    time: number;
    constructor(datas: string[], time: number = 1500) {
        super();
        this.datas = datas;
        this.time = time;
        this.initUI();
        this.start();
    }

    start() {

        const item1 = this.datas.shift();
        this.datas.push(item1);
        const item2 = this.datas.shift();
        this.datas.push(item2);

        this.buttonTxt1.text = item1;
        this.buttonTxt2.text = item2;

        this.buttonTxt1.y = 0;
        this.buttonTxt2.y = this.buttonTxt1.textHeight;


        let next;
        next = () => {

            FYGE.Tween.removeTweens(this.buttonTxt1);
            FYGE.Tween.removeTweens(this.buttonTxt2);

            if (this.buttonTxt1.y < 0) {
                const item = this.datas.shift();
                this.datas.push(item);
                this.buttonTxt1.text = item;
                this.buttonTxt1.y = this.buttonTxt1.textHeight;
                const tmp1 = this.buttonTxt1;
                const tmp2 = this.buttonTxt2;
                this.buttonTxt1=tmp2;
                this.buttonTxt2=tmp1;
            }

            FYGE.Tween.get(this.buttonTxt1)
                .to({ y: -this.buttonTxt1.textHeight }, this.time)

            FYGE.Tween.get(this.buttonTxt2)
                .to({ y: 0 }, this.time)
                .wait(2000)
                .call(next);
        }

        setTimeout(() => {
            next();
        }, 1000);


    }


    initUI() {
        // const bg = new FYGE.Shape();
        // bg.beginFill(0, 1);
        // bg.drawRoundedRect(0, 0, w, h, 5, 5, 5, 5);
        // bg.endFill();
        // this.addChild(bg);

        this.textwrapper = new FYGE.Sprite();
        this.textwrapper.x = gap;
        this.addChild(this.textwrapper);

        const mask = new FYGE.Shape();
        mask.beginFill(0, 1);
        mask.drawRoundedRect(0, 0, w - gap * 2, h, 5, 5, 5, 5);
        mask.endFill();
        this.textwrapper.addChild(mask);
        this.textwrapper.mask = mask;

        const buttonTxt = new FYGE.TextField;
        buttonTxt.textHeight = h;
        buttonTxt.size = 26;
        buttonTxt.verticalAlign = FYGE.VERTICAL_ALIGN.MIDDLE;
        buttonTxt.fillColor = '0xffffff';
        this.textwrapper.addChild(buttonTxt);
        this.buttonTxt1 = buttonTxt;


        const buttonTxt2 = new FYGE.TextField;
        buttonTxt2.textHeight = h;
        buttonTxt2.size = 26;
        buttonTxt2.verticalAlign = FYGE.VERTICAL_ALIGN.MIDDLE;
        buttonTxt2.fillColor = '0xffffff';
        this.textwrapper.addChild(buttonTxt2);
        this.buttonTxt2 = buttonTxt2;
    }

    dispose() {

    }
}