import { layers } from "../../module/views/layers";
import TestLabel from "./TestLabel";
let mask;
export default class ShareMask extends FYGE.Sprite {

    constructor(color = 0, alpha = .7, container?) {
        super();

        const bg = new FYGE.Shape();
        bg.beginFill(color, alpha);
        bg.drawRect(0, 0, 750, 1624);
        bg.endFill();
        this.addChild(bg);

        this.addChild(new TestLabel({
            text:'这是个分享引导蒙层',
            color:'0xffffff',w:750,h:1624
        }));

        if (container)
            container.addChild(this);

        let callback;
        callback = () => {
            this.parent && this.parent.removeChild(this);
            this.removeEventListener(FYGE.MouseEvent.CLICK, callback, this);
            mask=null;
        };

        this.addEventListener(FYGE.MouseEvent.CLICK, callback, this);
    }
}


export const showShareMask = ()=>{
    if(mask)return;
    mask = new ShareMask();
    layers.shareLayer.addChild(mask);
}
export const hideShareMask = ()=>{
    if(!mask) return;
    layers.shareLayer.removeChild(mask);
    mask=null;
}