import { RES } from "../../module/RES";
import { Panel } from "../../module/views/Panel";
import centerTextField from "../common/centerTextField";
import getObject from "../common/getObject";
import { getAutoPrizeUrl } from "../getShareUrl";

export class AssistPanel extends Panel {
	onClick_share_go(){
		location.href=getAutoPrizeUrl()
	}
	initUi() {
		super.initUi();
		var skin = RES.getSkinDataByName(this.skinName);
		this.position.set(skin.x, skin.y);
	}
	//两个按钮都是关闭作用
	get closeBtns() {
		return [getObject(this, 'assist_close')];
	}

	get groupNames() { return ["assist"] }
	get skinName() { return "assist" }


	async start(data) {
		super.start(data);
		getObject(this, 'assist_amout').text = `${data}`

		const prize_tips1 = getObject(this, 'assist_tips');
		const prize_tips2 = getObject(this, 'assist_amout');
		prize_tips2.text = data;
		const w = prize_tips1.textWidth + prize_tips2.textWidth;
		prize_tips2.x = (595 - w) / 2;
		prize_tips1.x = prize_tips2.x + prize_tips2.textWidth;
		centerTextField(getObject(this,'assist_tips2'),595)
	}

	initEvents() {
        super.initEvents();

       
        getObject(this, 'assist_btn').addEventListener(FYGE.MouseEvent.CLICK, this.onClick_share_go, this);
    }
    removeEvents() {
        super.removeEvents();
        
        getObject(this, 'assist_btn').removeEventListener(FYGE.MouseEvent.CLICK, this.onClick_share_go, this);
    }
}