import { hideWaiting, showPanel, showWaiting } from "../../module/ctrls";
import { Scene } from "../../module/views/Scene";
import centerTextField from "../common/centerTextField";
import getObject from "../common/getObject";
import getQueryParams from "../common/getQueryParams";
import Marquee from "../common/Marquee";
import { getAutoPrizeUrl } from "../getShareUrl";
import { AssistPanel } from "../panels/assist";
import { RulePanel } from "../panels/rule";
import { getPxTokenSave, sendWebNet, WebNetName } from "../WebNet";
export class ShareScene extends Scene {

    onClick_share_assist() {
        const query = getQueryParams();
        showWaiting();
        getPxTokenSave().then(token => {
            sendWebNet(WebNetName.assist, { code: query.code }).then(res => {
                hideWaiting();
                if (res.success)
                    showPanel(AssistPanel, res.data)
            })
        })

    }
    onClick_share_rule() {
        showPanel(RulePanel);
    }
    onClick_share_go() {
        location.href = getAutoPrizeUrl();
    }


    async start(data) {
        super.start();
        console.log('ShareScene query>>', JSON.stringify(getQueryParams()));

        const query = getQueryParams();

        sendWebNet(WebNetName.carouselInfo).then(res => {
        
            const template = '{phone}邀请1位好友，获得了{amount}体验金';
            const datas = res.data.map(item => {
                let str = template.replace('{phone}', item.nickname);
                str = str.replace('{amount}', item.amount);
                return str
            });
            const q = this.addChild(new Marquee(datas));
            q.x = 135; q.y = 448;
            window['q'] = q;
        });

        if (query.code) {
            getPxTokenSave().then(token => {
                sendWebNet(WebNetName.shareInfo, { code: getQueryParams().code, token: token }).then(res => {
                    const { experienceAmount, preIncom, remainAssist } = res.data;
                    getObject(this, 'share_tips1').text = `${experienceAmount}元体验金，预期收益${preIncom}元`
                    getObject(this, 'share_tips2').text = `今日剩余助力次数：${remainAssist}次`
                });
            })
        } else {
            getObject(this, 'share_assist').visible = false;
            getObject(this, 'share_tips3').text = '';
            const go = getObject(this, 'share_go');
            go.x = 750 / 2 - 234 * 1.5 / 2;
            go.y = 1110;
            go.scaleX = 1.5;
            go.scaleY = 1.5;
        }
    }

    initEvents() {
        super.initEvents();

        getObject(this, 'share_rule').addEventListener(FYGE.MouseEvent.CLICK, this.onClick_share_rule, this);
        getObject(this, 'share_assist').addEventListener(FYGE.MouseEvent.CLICK, this.onClick_share_assist, this);
        getObject(this, 'share_go').addEventListener(FYGE.MouseEvent.CLICK, this.onClick_share_go, this);
    }
    removeEvents() {
        super.removeEvents();
        getObject(this, 'share_rule').removeEventListener(FYGE.MouseEvent.CLICK, this.onClick_share_rule, this);
        getObject(this, 'share_assist').removeEventListener(FYGE.MouseEvent.CLICK, this.onClick_share_assist, this);
        getObject(this, 'share_go').removeEventListener(FYGE.MouseEvent.CLICK, this.onClick_share_go, this);
    }

    get groupNames() { return ["share"] }
    get skinName() { return "share" }


    initUi() {
        super.initUi();
        centerTextField(getObject(this, 'share_tips1'));
        centerTextField(getObject(this, 'share_tips2'));
    }

}
